; vivid-saturation.scm    version 1.00    Jan 15, 2004
;
; script-fu-vivid-saturation - A script that will saturate the image with
; vivid saturated colors. Other implementations of this script are calles
; "Digital Velvia".
;
; Requires plug-in-channel-mixer (included with GIMP 2.0)!
;
; This plug-in is made for Gimp-2.0 (works with 1.3 too)
;
; Changelog:
; 1.00 - initial release
;
; Copyright 2004 Olli Salonen <olli@cabbala.net>
;

(define (script-fu-vivid-saturation inImg inDrw inAmount)

  (let* (

	 (amount (/ inAmount 100)))

    (gimp-image-undo-group-start inImg)

    (plug-in-colors-channel-mixer TRUE inImg inDrw FALSE (+ 1 amount amount) (- amount) (- amount) (- amount) (+ 1 amount amount) (- amount) (- amount) (- amount) (+ 1 amount amount))

    (define (spline)
      (let* ((a (cons-array 8 'byte)))
	(set-pt a 0 0 0)
	(set-pt a 1 63 60)
	(set-pt a 2 191 194)
	(set-pt a 3 255 255)
	a))
  
    (gimp-curves-spline inDrw 0 8 (spline))

    (gimp-image-undo-group-end inImg)
    (gimp-displays-flush)
    )
  )


(script-fu-register "script-fu-vivid-saturation"
		    "<Image>/Script-Fu/Photokit/_Vivid Saturation"
		    "Vivid saturation of image. Gives similar effect as many \"Digital Velvia\" filters do for the Other Product."
		    "Olli Salonen <olli@cabbala.net>"
		    "Olli Salonen"
		    "Jan 15, 2004"
		    ""
		    SF-IMAGE              "Image"                0
		    SF-DRAWABLE           "Drawable"             0
		    SF-ADJUSTMENT         "Amount"              '(10 0 50 1 1 0 0))
